;********************************************************************************************************
;  kuber  trio-tv@mail.ru
;
;		16  2010 13.30
;	   gavrasm.
;	   .BAT .
;   	 "TwinPicks"
;
;  SKD    DS1990A  (Dallas).
;  EEPROM  24c16 
; -  500 .
;  -    JP1,JP2,JP3,JP4.
; ! "   "     JP2.
;
; JP1-   ,   1 .( -  )   32 .
; JP2-    ,   1 .( -  )
; JP3-    (max. 500)
; JP4-   .
;
; int OSC 8.0 MZh ,   8.
; BODLEVEL (00)- 4,3V
;  FUSE  .	
;
;********************************************************************************************************
;
;
.include "tn2313def.inc"
;
.def	reg_rd_ds		= R18	
.def	reg_wr_ds		= R20	
;
.def	Reg_r18		= R18
.def	Reg_r20		= R20
;
.def 	temp      	 	= R25
;
.def	temp_1	 	= R16
.def    	temp_2     		= R21
.def   	temp_3     		= R22
;
.def	Flag_R	   	= R23	; 0 ,  
.def	Flag_RAM   	= R24	
;
;
.def	S		= R12

.def	push_temp	= R11
;
;
.def	timer_Hi		= R6
;
;
;
;----------------------------------------------------------------------
;
.equ time_wait_close_door	= 4	;   24xxx   "   "
.equ time_out		= 5	;   24xxx  "  ."
.equ num_string		= 6	; Low    24xxx      .
.equ num_string_High	= 7	; High   24xxx      .
.equ ee_adres_ds_code	= 8	;   EEPROM  .
;
;----------------------------------------------------------------------
;
.dseg
;
Wait_close_door:		.byte	1 ;      .
Flags_door:		.byte	1 ;  
;
count1:			.byte	1
pulse_led_with:		.byte	1
;
count_prog_off:		.byte	1
.equ	const_count_prog_off = 50;	;     .
;
count_master_prog:		.byte	1
.equ	count_master_read    = 25	;      .
;
;
.equ	pulse_led_const	   = 35	;       
.equ	pulse_prog_led_const = 5	;       
;
;---------------------------------------------------
;
.EQU	bip_pin		   = 5	;    
.SET	bip_port		   = PORTB
;
;
.equ	const_del_tmr	=3
;
;----------------------------------
;
.equ	Eras_JP1_pin	= 0
.equ	Eras_JP1_mask	= 0B00111000	;
;
.equ	Prog_JP2_pin	= 1
.equ	Prog_JP2_mask	= 0B01011000	;
;
.equ	T_Siten_JP3_pin	= 2
.equ	T_Siten_JP3_mask	= 0B01101000	;
;
.equ	T_Out_JP4_pin	= 3
.equ	T_Out_JP4_mask	= 0B01110000	;
;
;-----------------------------------
;
.equ	JP1JP2_port	= PORTB
.equ	JP_PINx		= PINB
.equ	JP_DDRx		= DDRB
;
.equ	LedR_pin		= 7
.equ	LedG_pin		= 6
.equ	Led_port		= PORTB
;
;
.equ	Rele_pin		= 4
.equ	Rele_port		= PORTB
;
;
.equ	knopka_in		= 2	 ;    .
.equ	concevic_pin	= 3	;    
.equ	concevic_port	= PIND
;
;
;--------------------------------------------------
;
a:			.byte	 1
b:			.byte	 1
dsrd:			.byte	 7
crc:			.byte	 1
dsrd2:			.byte	 7
crc2:			.byte	 1		
;
;--------------------------------------------------
;
;
wait_open_ram:	.	byte	1;  -  
;
;
.equ	wait_open_const	= 1
;
;
;-------------------------------------------------------------
; Interrupt service vectors
.cseg
.org 0
;
	rjmp	Reset		
;
	rjmp	INT0addrS	; 0x0001	; External Interrupt Request 0
	rjmp	INT1addrS	; 0x0002	; External Interrupt Request 1
	rjmp	ICP1addrS	; 0x0003	; Timer/Counter1 Capture Event
	rjmp	OC1AaddrS	; 0x0004	; Timer/Counter1 Compare Match A
	rjmp	OVF1addrS	; 0x0005	; Timer/Counter1 Overflow
	rjmp	OVF0addrS	; 0x0006	; Timer/Counter0 Overflow
	rjmp	URXCaddrS	; 0x0007	; USART, Rx Complete
	rjmp	UDREaddrS	; 0x0008	; USART Data Register Empty
	rjmp	UTXCaddrS	; 0x0009	; USART, Tx Complete
	rjmp	ACIaddrS		; 0x000a	; Analog Comparator
	rjmp	PCIaddrS		; 0x000b	; 
	rjmp	OC1BaddrS	; 0x000c	; 
	rjmp	OC0AaddrS	; 0x000d	; 
	rjmp	OC0BaddrS	; 0x000e	; 
	rjmp	USI_STARTaddrS	; 0x000f	; USI Start Condition
	rjmp	USI_OVFaddrS	; 0x0010	; USI Overflow
	rjmp	ERDYaddrS	; 0x0011	; 
	rjmp	WDTaddrS	; 0x0012	; Watchdog Timer Overflow
;
;====================================================================
;
INT0addrS:
	reti
INT1addrS:
	reti
ICP1addrS:
	reti
OC1AaddrS:
	reti
OVF1addrS:
	reti
OVF0addrS:
	reti
URXCaddrS:
	reti
UDREaddrS:
	reti
UTXCaddrS:
	reti
ACIaddrS:
	reti
PCIaddrS:
	reti
OC1BaddrS:
	reti
;;OC0AaddrS:
;;	reti
OC0BaddrS:
	reti
USI_STARTaddrS:
	reti
USI_OVFaddrS:
	reti
ERDYaddrS:
	reti
WDTaddrS:
	reti
;
;-----------------------------------------------------------------
;    
;
.include  "t2313_ds1990A.asm"
.include  "i2c_soft.asm"
.include	"24c16_i2c.asm"		
;
; 	Start 
;
Reset:
;
	ldi 	temp,low(RAMEND)
	out 	SPL,temp
;
	ldi	temp,255
	out 	DDRA,temp
	ldi	temp,0	
	out	PORTA,temp
;
	ldi	temp,255-8-4-2-1	
	out 	DDRB,temp
	ldi	temp,0	
	out	PORTB,temp
;
	ldi	temp,0		
	out 	DDRD,temp
	ldi	temp,2+4	
	out	PORTD,temp
;
;
;-------------------------------
;Timer0 OC0A
;------------------------------
	ldi	temp,0b00000010		
	out	TCCR0A,temp
;
	ldi	temp,0b00000101			
	out	TCCR0B,temp
;
	ldi	temp,0b00000000
	out	TCNT0,temp
;
	ldi	temp,232	;32		
	out	OCR0A,temp
;
	ldi	temp,1<<OCIE0A		
	out	TIMSK,temp
;
;------------------------------------
;
	sbi	ACSR,7		; comparator disable
;
;------------------------------------
;
	rcall	master_prog
;
	clr	Flag_R
	clr	flag_RAM
;
	sts	(count1),flag_RAM
	sts	(wait_open_ram),flag_RAM
	sts	(count_prog_off),flag_RAM
	sts	(count_master_prog),flag_RAM
;
	ldi	temp,pulse_led_const
	sts	(pulse_led_with),temp
;
;-------------------------
;
	clr	temp
	out	MCUSR,temp
;
;-------------------------
;
;

	sei
;
;*******************************
;  
;
main:
;
	rcall	ReadDS			;    
;
	sbrs	Flag_R,0			;  (0-)   
	rjmp	err_ready_ir
;
	rcall	EE_compare_DS_paket 	;         EEPROM
;
;err_ready_ir:
;
	sbrc	Flag_R,2	  		;  (2-)   
	rcall	master_bip		;   
	sbrc	Flag_R,3	   		;  (3-)    
	rcall	card_bip	   		;   .
;
err_ready_ir:
;
	rcall	knopka	   		;     
;
	rcall	jp_select			;    JP1,JP2,JP3,JP4.
;
	rcall	gerkon_door		;   .
;
	sbrc	flag_RAM,4 		; 4 -  
	rcall	biper_end_prog
;
	rjmp	main
;
;******************************************************************************************
;     ( )
;          .
;
gerkon_door:
;
	sbis	concevic_port,concevic_pin	; PORTD.3  .
	ret
;
	rcall	delay100			
;
	sbis	concevic_port,concevic_pin	; PORTD.3  .
	rjmp	con_open_door
;
	lds	temp_2,(Flags_door)		;  .
	sbrc	temp_2,0
	rjmp	time_door_out
;
	sbr	temp_2,1
	sts	(Flags_door),temp_2
;
	ret
;-----
time_door_out:
;
	lds	temp_2,(Wait_close_door)
	tst	temp_2
	breq	tim_out
	ret
;-----
tim_out:
	rcall	biper
	rcall	biper
;
	ret
;-----
con_open_door:
;
	lds	temp_2,(Flags_door)
	cbr	temp_2,1
	sts	(Flags_door),temp_2
;
	ret
;
;------------------
;
master_bip:
;
	rcall	delay100
;
	lds	temp_1,(count_master_prog)
	inc	temp_1
	sts	(count_master_prog),temp_1
	cpi	temp_1,count_master_read
	breq	mas_bip
	ret
mas_bip:
	clr	temp_1
	sts	(count_master_prog),temp_1
;
	rcall	knopka
;
	sbrs	flag_RAM,7
	rjmp	jp1			;  
	rjmp	jp2			;    
;
;--------------------------------------------------------------------
;
card_bip:
;
	cbr	Flag_R,0b00001000
;
	ldi	ZL,low(time_out)
	ldi	ZH,high(time_out)
;
	rcall	EEprom_read
;
	andi	temp_1,0B00011111		;    32 
	sts	(wait_open_ram),temp_1
;
bip_rele:
;
	sbi	Led_port,LedG_pin
	cbi	Led_port,LedR_pin
;
	sbi	Rele_port,Rele_pin		;  OUT
;
	ldi	ZL,low(time_wait_close_door)
	ldi	ZH,high(time_wait_close_door)
	rcall	EEprom_read
	sts	(Wait_close_door),temp_1
;
	rcall	biper
;
	ret
;
;--------------------------------------------------------------------
;     .
;
master_prog:
;
	clr	temp_2
m_p1:
	rcall	knopka
;
	sbrs	flag_RAM,7
	ret
;
	rcall	delay500
	inc	temp_2
	cpi	temp_2,10
	brlo	m_p1
;
	sbr	flag_RAM,0B00001000 	;    
;
	ldi	temp_1,pulse_prog_led_const
	sts	(pulse_led_with),temp_1
;
	ldi	temp_1,0
	sts	(wait_open_ram),temp_1
;
	rcall	biper
;
	ldi	temp,const_count_prog_off
	sts	(count_prog_off),temp
;
	rcall	jp0
	rcall	biper_end_prog
;
	ret
;
;----------------------------
;
; 
;
del_11ms:
pause:
;
delay100:
	push	temp_1
	push	temp_2
	push	temp_3
;
	ldi	temp_3,100
;
d_Wms:	ldi	temp_1,0x14
d_Wms1:	ldi	temp_2,0x85
d_Wms2:	dec	temp_2
	brne	d_Wms2
	dec	temp_1
	brne	d_Wms1
	dec	temp_3
	brne	d_Wms
;
	pop	temp_3
	pop	temp_2
	pop	temp_1
;
	ret
;
delay500:
	rcall	delay100
delay400:
	rcall	delay100
delay300:	
	rcall	delay100
delay200:
	rcall	delay100
	rcall	delay100
;
	ret
;
;--
;
delay:
	push	temp
	ldi	temp,50
del0:
	dec 	temp
	brne	del0
	pop	temp
;
	ret
;
;------------------------------------
;
biper_end_prog:
;
	rcall	biper
	rcall	biper
	rcall	biper
	rcall	biper
	rcall	biper
;
	clr	Flag_R
	cbr	flag_RAM,0B00110000 	;  5,4 -  
;
	ret
;
;--------------------------------------------------------------------------------------
;
;   (   (wait_open_ram))
;
biper:
;
	sbi	bip_port,bip_pin
	rcall	delay100
	cbi	bip_port,bip_pin
	rcall	delay100
;
	lds	temp,(wait_open_ram)
	tst	temp
	brne	biper
;
	ret
;
;
;-----------------------------------------------------------------------------
;    OPEN
;------------------------------------------------------------------------------
;
;
knopka:
;
	sbic	PIND,knopka_in
	rjmp	knopka_off
;
	rcall	delay100
;
	sbic	PIND,knopka_in
	rjmp	knopka_off
;
;knopka_on
;
	sbrs	flag_RAM,7
	rcall	rd_var_wait_open
	sbr	flag_RAM,0b10000000 	; 7-  / 
;
	ret
;
knopka_off:
;
	cbr	flag_RAM,0b10000000 	; 7-  / 
;
;
	ret
;
;------------------------------------------------------
;
;   
;
rd_var_wait_open:
;
	lds	temp_1,(wait_open_ram)
	tst	temp_1
	breq	rd_var_1
	ret
;
rd_var_1:
;
	ldi	ZL,low(time_out)
	ldi	ZH,high(time_out)
;
	rcall	EEprom_read
;
	andi	temp_1,0B00011111      	;    32 
	sts	(wait_open_ram),temp_1
;
	in	temp_1,MCUSR
	sbrs	temp_1,0	   	       	;    
	rcall	bip_rele
;
	sbr	flag_RAM,0b00000001  	; 0-  
;
	ret
;
;***************************************************************************
;	     OC0A
;
;Timer0 OCA
OC0Aaddrs:
;
	in	S,sreg
;
	mov	push_temp,temp	
;
	inc	timer_Hi
;
	lds	temp,(pulse_led_with)
;---
	cp	timer_Hi,temp
	brlo	fir_st
;
	clr	timer_Hi
;
	lds	temp_1,(Wait_close_door)
	tst	temp_1
	breq	w_c_d
	dec	temp_1
	sts	(Wait_close_door),temp_1
;
w_c_d:
;
	lds	temp_1,(count_master_prog)
	tst	temp_1
	breq	cn_ms_rst
	dec	temp_1
	sts	(count_master_prog),temp_1
;
;;;	rcall	biper
;
cn_ms_rst:
;
	lds	temp,(count_prog_off)
	tst	temp
	breq	no_progrs
	cpi	temp,1
	brne	no_prog_off_bip
;
	sbr	flag_RAM,0B00010000 	; 4 -  
;
no_prog_off_bip:
;
	dec	temp
	sts	(count_prog_off),temp
	rjmp	yes_progrs
;
no_progrs:
	cbr	flag_RAM,0B00101000 	; 5,3 -    
;
	ldi	temp_1,pulse_led_const
	sts	(pulse_led_with),temp_1
;
yes_progrs:
;
	lds	temp,(wait_open_ram)
	tst	temp
	breq	no_count_wait_open
	dec	temp
	sts	(wait_open_ram),temp
	rjmp	cou1
;
no_count_wait_open:
;
	cbi	Led_port,LedG_pin
;
	cbi	Rele_port,Rele_pin		;  OUT
;
	lds	temp,(count1)
	cpi	temp,0
	breq	cou1
	ldi	temp,0
	sts	(count1),temp
;
	sbi	Led_port,LedR_pin	
;
	rjmp	fir_st
;
cou1:
;
	cbi	Led_port,LedR_pin	
;
	ldi	temp,1
	sts	(count1),temp
;
fir_st:
;
TIM0_OVF_exit:
;
	out	sreg,S
;
	mov	temp,push_temp
;
	reti
;
;********************************************************************
;
;  
;
jp0:
;
	ldi	ZL,low(time_out)
	ldi	ZH,high(time_out)
;
	ldi	temp_1,0		
	rcall	EEprom_write
;
jp00:
	sbrs	flag_RAM,3 		;    
	ret
;
	rcall	ReadDS			
;
	sbrc	Flag_R,0
	rcall	count_master_wait
;
	rjmp	jp00
;
;--------
;
count_master_wait:
;
	ldi	ZL,low(time_out)
	ldi	ZH,high(time_out)
;
	rcall	EEprom_read
	inc	temp_1			;    
;
	rcall	EEprom_write
;
	ldi	ZL,low(ee_adres_ds_code)
	ldi	ZH,high(ee_adres_ds_code)
;
	rcall	master_key_wr	
;
	rcall	biper
	rcall	delay500
;
	ldi	temp,const_count_prog_off
	sts	(count_prog_off),temp
;
	ret
;
;*********************************************************************
;
;
;  
;
jp1:
;
	ldi	temp,pulse_prog_led_const
	sts	(pulse_led_with),temp
;
;
	ldi	temp_1,const_count_prog_off
	sts	(count_prog_off),temp_1
;
jp11:
;
	lds	temp,(count_prog_off)
	tst 	temp	
	brne	jp111
;
	ldi	temp,pulse_led_const
	sts	(pulse_led_with),temp
;
	rjmp	biper_end_prog
;
jp111:
;
	ldi	ZL,low(num_string)
	ldi	ZH,high(num_string)
	rcall	EEprom_read
	mov	XL,temp_1
	adiw	ZL,1
	rcall	EEprom_read
	mov	XH,temp_1
;
;
	cpi	XH,high(501)		; 500  -  24c16
	brsh	ee_key_yes		;   - 
;
	rcall	ReadDS			
;
	sbrs	Flag_R,0
	rjmp	jp11
;
	rcall	EE_compare_DS_paket
;
	sbrc	Flag_R,3
	rjmp	ee_key_yes
;
	sbrc	Flag_R,2
	rjmp	ee_key_yes
;
	rcall	EE_wr_rf_4bytes
;
	ldi	ZL,low(num_string)
	ldi	ZH,high(num_string)
	rcall	EEprom_read
	mov	XL,temp_1
	adiw	ZL,1
	rcall	EEprom_read
	mov	XH,temp_1
;
	adiw	XL,1
	mov	temp_1,XH
	rcall	EEprom_write
	sbiw	ZL,1
	mov	temp_1,XL
	rcall	EEprom_write
;
	rjmp	e_ky			;    
;
;**************************************************************************
;       
;    
;  "  "  "   "  
;
jp2:
Erase_all_code_key:
;
	sbi	bip_port,bip_pin
;
	rcall	EE_erase_all
;
	ldi	ZL,low(num_string)
	ldi	ZH,high(num_string)
	ldi	temp_1,1			; Low      
	rcall	EEprom_write
	adiw	ZL,1
	ldi	temp_1,0			; High     
	rcall	EEprom_write
;
	cbi	bip_port,bip_pin
;
	ret
;
;***********************************************************************
;
ee_key_yes:
;
	rcall	biper
e_ky:
	rcall	biper
;
	rcall	delay500
;
	ldi	temp_1,const_count_prog_off
	sts	(count_prog_off),temp_1
;
	rjmp	jp1		;11
;
;**********************************************************************
;
;    
;
jp_select:
;
	rcall	read_jp
	brts	jp_yes
	ret
;
jp_yes:
;
	cpi	temp,0B00001110	
	breq	first_cmd1
;
	cpi	temp,0B00001101	
	breq	first_cmd2
;
	cpi	temp,0B00001011
	breq	first_cmd3
;
	cpi	temp,0B00000111
	breq	first_cmd4
;
	ret
;
first_cmd1:
	rjmp	cmd1
first_cmd2:
	rjmp	cmd2
first_cmd3:
	rjmp	cmd3
first_cmd4:
	rjmp	cmd4
;
;-------
;
read_jp:
	set
	in	temp,PINB
	andi	temp,0B00001111
;
	rcall	delay100
;
	in	temp_2,PINB
	andi	temp_2,0B00001111
;
	cpse	temp,temp_2
	clt
	ret
;
;----------------------------------------------------------------------------------------
;    
;      .
;
;     
;   1.
;  JP1 - 0B00001110
;
cmd1:
;
	cbi	Led_port,LedR_pin	
;
	rcall	delay500		;  0,5 .   
;
	ldi	temp_1,1		; 1 -    .
;
jp1_loop:
;
	rcall	read_jp
	brts	jp1_close
	ret
jp1_close:
	cpi	temp_2 ,0B00001110
	breq	jp1_yes
	ret
;
jp1_yes:
;
	ldi	ZL,low(time_out)
	ldi	ZH,high(time_out)
	rcall	EEprom_write
;
	cli
;
	rcall	delay500
;
	sbi	Led_port,LedG_pin	
	rcall	biper
	cbi	Led_port,LedG_pin	
;
	ldi	ZL,low(time_out)
	ldi	ZH,high(time_out)
	rcall	EEprom_read
;
	cpi	temp_1,254	;      - 255 .
	breq	jp1_yes	
;
	inc	temp_1		;     .
;
	rjmp	jp1_loop
;
	sei
;
	ret
;
;----------------------------------------------------------------------------------------
;    .
;      .
;
;      .
;   10.
;   1.
;   - time_wait_close_door (2416)
;  JP2 - 0B00001101
;
cmd2:
;
	cbi	Led_port,LedR_pin	
;
	rcall	delay500		;  0,5 .   
;
	ldi	temp_1,9		; 10 -     .
;
jp2_loop:
;
	rcall	read_jp
	brts	jp2_close
	ret
jp2_close:
	cpi	temp_2,0B00001101
	breq	jp2_yes
	ret
;
jp2_yes:
;
	ldi	ZL,low(time_wait_close_door)
	ldi	ZH,high(time_wait_close_door)
	rcall	EEprom_write
;
	cli
;
	rcall	delay500
;
	sbi	Led_port,LedG_pin	
	rcall	biper
	cbi	Led_port,LedG_pin	
;
	ldi	ZL,low(time_wait_close_door)
	ldi	ZH,high(time_wait_close_door)
	rcall	EEprom_read
;
	cpi	temp_1,254	;      - 255 .
	breq	jp2_yes	
;
	inc	temp_1		;      .
;
	rjmp	jp2_loop
;
	sei
;
	ret
;
;-----------------------------------------------------------------------------------------
;        EEPROM 24c16
;      .
;  JP3 - 0B00001011
;
cmd3:
;
	rcall	delay500		;  0,5 .   	
;
	rcall	read_jp
	brts	jp3_close
	ret
jp3_close:
	cpi	temp_2,0B00001011
	breq	jp3_yes
	ret
;
jp3_yes:
;
	ldi	ZL,low(num_string)
	ldi	ZH,high(num_string)
	rcall	EEprom_read
	mov	XL,temp_1
	adiw	ZL,1
	rcall	EEprom_read
	mov	XH,temp_1
;
;
	cpi	XH,high(501)	; 500  -  24c16
	brsh	ee_full		;   - 
;
	rcall	ReadDS			
;
	sbrs	Flag_R,0
	rjmp	cmd3
;
	rcall	EE_compare_DS_paket
;
	sbrc	Flag_R,3
	rjmp	code_key_yes	;    
;
	sbrc	Flag_R,2
	rjmp	code_key_yes	;    
;
	rcall	EE_wr_rf_4bytes
;
	ldi	ZL,low(num_string)
	ldi	ZH,high(num_string)
	rcall	EEprom_read
	mov	XL,temp_1
	adiw	ZL,1
	rcall	EEprom_read
	mov	XH,temp_1
;
	adiw	XL,1
	mov	temp_1,XH
	rcall	EEprom_write
	sbiw	ZL,1
	mov	temp_1,XL
	rcall	EEprom_write
;
	sbi	Led_port,LedG_pin	
	rcall	biper		;    
	cbi	Led_port,LedG_pin	
;
	rjmp	cmd3
;
;----------
; 
code_key_yes:
;
	rcall	biper
;
ee_full:
	rcall	biper
;
	rjmp	cmd3
;
;------------------------------------------------------------------------------------------
;     
;      .
;  JP4 - 0B00000111
;
cmd4:
;
	rcall	biper
	rcall	biper
	rcall	biper
	rcall	biper
	rcall	biper
;
	rcall	delay500		;  0,5 .   
	rcall	delay500		;  0,5 .   	
;
	rcall	read_jp
	brts	jp4_close
	ret
jp4_close:
	cpi	temp_2,0B00000111
	breq	jp4_yes
	ret
;
jp4_yes:
;
	rcall	Erase_all_code_key	;      .
;
jp4_no_open:
;
	rcall	read_jp
	brts	jp4_no_open
;
	ret
;
;
;--------------------------------------
; end